/*
*********************************************************************************************************
*											        eBase
*						                the Abstract of Hardware
*									           the OAL of PIO
*
*						        (c) Copyright 2006-2010, AW China
*											All	Rights Reserved
*
* File    	: 	pin.h
* Date		:	2010-11-15
* By      	: 	holi
* Version 	: 	V1.00
* Description:
*
*********************************************************************************************************
*/
#include "include.h"
#include "string.h"

typedef struct
{
	int mul_sel;
	int pull;
	int drv_level;
	int data;
}
gpio_status_set_t;

typedef struct
{
    char    gpio_name[32];
    int port;
	int port_num;
    gpio_status_set_t user_gpio_status;
    gpio_status_set_t hardware_gpio_status;
}
system_gpio_set_t;
/*
****************************************************************************************************
*
*             CSP_PIN_init
*
*  Description:
*       init
*
*  Parameters:
*		p_sys_srv	:	cspϵͳ
*		p_cfg		:	pin
*  Return value:
*		EBSP_TRUE/EBSP_FALSE
****************************************************************************************************
*/
__s32 eGon2_GPIO_init(void)          //GPIOʼӿ
{
	return 0;
}
/*
****************************************************************************************************
*
*             CSP_PIN_exit
*
*  Description:
*       exit
*
*  Parameters:
*
*  Return value:
*		EBSP_TRUE/EBSP_FALSE
****************************************************************************************************
*/
__s32 eGon2_GPIO_exit(void)		    //GPIOƳӿ
{
	return 0;
}
/*
************************************************************************************************************
*
*                                             CSP_PIN_DEV_req
*
*    ƣ
*
*    бgpio_list      õGPIOݵ飬GPIOֱʹ
*
*			   group_count_max  ĳԱGPIO趨ʱ򣬽GPIO󲻳ֵ
*
*    ֵ  
*
*    ˵    ʱûͻ
*
*
************************************************************************************************************
*/
//ûݱ뱣
//ķûʱȥmallocڵǿ mallocȽ϶࣬ܳСݵ
//ڳʼʱGPIOȫ,СICпԷGPIOĸǱȽԿơڱӦGPIOӦݵ
//
//ʹmallocķϾ
__hdle eGon2_GPIO_Request(user_gpio_set_t *gpio_list, __u32 group_count_max)  //豸GPIOӿ
{
    char               *user_gpio_buf;                                        //char
	system_gpio_set_t  *user_gpio_set, *tmp_sys_gpio_data;					  //user_gpio_setڴľ
	user_gpio_set_t  *tmp_user_gpio_data;
	__u32				real_gpio_count = 0;                                  //ЧGPIOĸ
	__u32               tmp_group_func_data;
	__u32               tmp_group_pull_data;
	__u32               tmp_group_dlevel_data;
	__u32               tmp_group_data_data;
	__u32               pull_change = 0;
	__u32               dlevel_change = 0, data_change = 0;
	volatile __u32  *tmp_group_func_addr = NULL, *tmp_group_pull_addr = NULL;
	volatile __u32  *tmp_group_dlevel_addr = NULL, *tmp_group_data_addr = NULL;
	__u32  port, port_num, port_num_func, port_num_pull;
	__u32  pre_port = 0x7fffffff, pre_port_num_func = 0x7fffffff;
	__u32  pre_port_num_pull = 0x7fffffff;
	__s32               i, tmp_val;

	//ûݵЧ
	if((!gpio_list) || (!group_count_max))
	{
		return (__hdle)0;
	}
	//鿴ûЧĸ
	for(i = 0; i < group_count_max; i++)
	{
		tmp_user_gpio_data = gpio_list + i;                 //gpio_setָÿGPIOԱ
	    if(!tmp_user_gpio_data->port)
	    {
	    	continue;
	    }
	    real_gpio_count ++;
	}
    //ЧGPIOռ
	user_gpio_buf = (char *)eGon2_malloc(16 + sizeof(system_gpio_set_t) * real_gpio_count);   //ڴ棬16ֽڣڴGPIOϢ
	if(!user_gpio_buf)
	{
		return (__hdle)0;
	}
	memset(user_gpio_buf, 0, 16 + sizeof(system_gpio_set_t) * real_gpio_count);         //ȫ
	*(int *)user_gpio_buf = real_gpio_count;                                           //ЧGPIO
	user_gpio_set = (system_gpio_set_t *)(user_gpio_buf + 16);                         //ָһṹ
	//û
	for(i = 0; i < group_count_max; i++)
	{
		tmp_sys_gpio_data  = user_gpio_set + i;             //tmp_sys_gpio_dataָGPIOռ
		tmp_user_gpio_data = gpio_list + i;                 //gpio_setָûÿGPIOԱ
	    port     = tmp_user_gpio_data->port;                //˿ֵ
	    port_num = tmp_user_gpio_data->port_num;            //˿еĳһGPIO
	    if(!port)
	    {
	    	continue;
	    }
	    //ʼû
	    strcpy(tmp_sys_gpio_data->gpio_name, tmp_user_gpio_data->gpio_name);
	    tmp_sys_gpio_data->port                       = port;
	    tmp_sys_gpio_data->port_num                   = port_num;
	    tmp_sys_gpio_data->user_gpio_status.mul_sel   = tmp_user_gpio_data->mul_sel;
	    tmp_sys_gpio_data->user_gpio_status.pull      = tmp_user_gpio_data->pull;
	    tmp_sys_gpio_data->user_gpio_status.drv_level = tmp_user_gpio_data->drv_level;
	    tmp_sys_gpio_data->user_gpio_status.data      = tmp_user_gpio_data->data;


        port_num_func = (port_num >> 3);
        port_num_pull = (port_num >> 4);

        if(tmp_group_func_addr)                             //ĴǷ񱻸ֵ
        {
            if((port_num_pull != pre_port_num_pull) || (port != pre_port))    //ֵǰŵĶ˿ڲһ£ڵpullĴһ
            {
                *tmp_group_func_addr   = tmp_group_func_data;    //дܼĴ
                if(pull_change)
                {
                    pull_change = 0;
                    *tmp_group_pull_addr   = tmp_group_pull_data;    //дpullĴ
                }
                if(dlevel_change)
                {
                    dlevel_change = 0;
                    *tmp_group_dlevel_addr = tmp_group_dlevel_data;  //дdriver levelĴ
                }
                if(data_change)
                {
                    data_change = 0;
                    *tmp_group_data_addr   = tmp_group_data_data;    //д
                }

                tmp_group_func_addr    = PIO_REG_CFG(port, port_num_func);   //¹ܼĴַ
                tmp_group_pull_addr    = PIO_REG_PULL(port, port_num_pull);   //pullĴ
                tmp_group_dlevel_addr  = PIO_REG_DLEVEL(port, port_num_pull); //levelĴ
                tmp_group_data_addr    = PIO_REG_DATA(port);                  //dataĴ

                tmp_group_func_data    = *tmp_group_func_addr;
                tmp_group_pull_data    = *tmp_group_pull_addr;
                tmp_group_dlevel_data  = *tmp_group_dlevel_addr;
                tmp_group_data_data    = *tmp_group_data_addr;
            }
            else if(pre_port_num_func != port_num_func)                       //ֵǰŵĹܼĴһ
            {
                *tmp_group_func_addr   = tmp_group_func_data;    //ֻдܼĴ
                tmp_group_func_addr    = PIO_REG_CFG(port, port_num_func);   //¹ܼĴַ

                tmp_group_func_data    = *tmp_group_func_addr;
            }
        }
        else
        {
            tmp_group_func_addr    = PIO_REG_CFG(port, port_num_func);   //¹ܼĴַ
            tmp_group_pull_addr    = PIO_REG_PULL(port, port_num_pull);   //pullĴ
            tmp_group_dlevel_addr  = PIO_REG_DLEVEL(port, port_num_pull); //levelĴ
            tmp_group_data_addr    = PIO_REG_DATA(port);                  //dataĴ

            tmp_group_func_data    = *tmp_group_func_addr;
            tmp_group_pull_data    = *tmp_group_pull_addr;
            tmp_group_dlevel_data  = *tmp_group_dlevel_addr;
            tmp_group_data_data    = *tmp_group_data_addr;
        }
		//浱ǰӲĴ
        pre_port_num_pull = port_num_pull;                      //õǰGPIOΪǰһGPIO
        pre_port_num_func = port_num_func;
        pre_port          = port;

        //¹ܼĴ
        tmp_val = (port_num - (port_num_func<<3)) << 2;
        tmp_sys_gpio_data->hardware_gpio_status.mul_sel = (tmp_group_func_data >> tmp_val) & 0x07;
        tmp_group_func_data &= ~(                              0x07  << tmp_val);
        tmp_group_func_data |=  (tmp_user_gpio_data->mul_sel & 0x07) << tmp_val;
        //pullֵǷpullĴ
        tmp_val              =  (port_num - (port_num_pull<<4)) << 1;
        tmp_sys_gpio_data->hardware_gpio_status.pull = (tmp_group_pull_data >> tmp_val) & 0x03;
        if(tmp_user_gpio_data->pull >= 0)
        {
            tmp_group_pull_data &= ~(                           0x03  << tmp_val);
            tmp_group_pull_data |=  (tmp_user_gpio_data->pull & 0x03) << tmp_val;
            pull_change = 1;
        }
        //driver levelֵǷdriver levelĴ
        tmp_sys_gpio_data->hardware_gpio_status.drv_level = (tmp_group_dlevel_data >> tmp_val) & 0x03;
        if(tmp_user_gpio_data->drv_level >= 0)
        {
            tmp_group_dlevel_data &= ~(                                0x03  << tmp_val);
            tmp_group_dlevel_data |=  (tmp_user_gpio_data->drv_level & 0x03) << tmp_val;
            dlevel_change = 1;
        }
        //û룬ԼܷǷdataĴ
        if(tmp_user_gpio_data->mul_sel == 1)
        {
            if(tmp_val >= 0)
            {
            	tmp_val = tmp_user_gpio_data->data;
            	tmp_val &= 1;
                tmp_group_data_data &= ~(1 << port_num);
                tmp_group_data_data |= tmp_val << port_num;
                data_change = 1;
            }
        }
    }
    //forѭڻûлдļĴдصӲ
    if(tmp_group_func_addr)                         //ֻҪ¹ĴַͿԶӲֵ
    {                                               //ôеֵȫдӲĴ
        *tmp_group_func_addr   = tmp_group_func_data;       //дܼĴ
        if(pull_change)
        {
            *tmp_group_pull_addr   = tmp_group_pull_data;    //дpullĴ
        }
        if(dlevel_change)
        {
            *tmp_group_dlevel_addr = tmp_group_dlevel_data;  //дdriver levelĴ
        }
        if(data_change)
        {
            *tmp_group_data_addr   = tmp_group_data_data;    //дdataĴ
        }
    }

    return (__hdle)user_gpio_buf;
}

//ͨIODEVICEIOһ𣬼ⲿӿ
/*
****************************************************************************************************
*
*             CSP_PIN_DEV_release
*
*  Description:
*       ͷĳ߼豸pin
*
*  Parameters:
* 		p_handler	:	handler
*
*  Return value:
*		EBSP_TRUE/EBSP_FALSE
****************************************************************************************************
*/
__s32 eGon2_GPIO_Release(__hdle p_handler, __s32 if_release_to_default_status)
{
    char               *tmp_buf;                                        //תchar
    __u32               group_count_max;                                //GPIO
    system_gpio_set_t  *user_gpio_set, *tmp_sys_gpio_data;
    __u32               tmp_group_func_data;
    volatile __u32  *tmp_group_func_addr = NULL;
    __u32               port, port_num, port_num_func;
    __u32               pre_port = 0x7fffffff, pre_port_num_func = 0x7fffffff;
    __u32               i;

    //鴫ľЧ
    if(!p_handler)
    {
        return EGON2_FAIL;
    }
    tmp_buf = (char *)p_handler;
    group_count_max = *(int *)tmp_buf;
    if(!group_count_max)
    {
        return EGON2_FAIL;
    }
    if(if_release_to_default_status == 2)
    {
        eGon2_free((char *)p_handler);

        return EGON2_OK;
    }
    user_gpio_set = (system_gpio_set_t *)(tmp_buf + 16);
	//ȡû
	for(i = 0; i < group_count_max; i++)
	{
		tmp_sys_gpio_data  = user_gpio_set + i;             //tmp_sys_gpio_dataָGPIOռ
	    port     = tmp_sys_gpio_data->port;                 //˿ֵ
	    port_num = tmp_sys_gpio_data->port_num;             //˿еĳһGPIO

        port_num_func = (port_num >> 3);

        if(tmp_group_func_addr)                             //ĴǷ񱻸ֵ
        {
            if((pre_port_num_func != port_num_func) || (port != pre_port)) //ֵǰŵĶ˿ڲһ£ڵpullĴһ
            {
                *tmp_group_func_addr = tmp_group_func_data;                //дܼĴ
                tmp_group_func_addr  = PIO_REG_CFG(port, port_num_func);   //¹ܼĴַ

                tmp_group_func_data = *tmp_group_func_addr;
            }
        }
        else
        {
            tmp_group_func_addr = PIO_REG_CFG(port, port_num_func);       //¹ܼĴַ

            tmp_group_func_data = *tmp_group_func_addr;
        }

        pre_port_num_func = port_num_func;
        pre_port          = port;
        //¹ܼĴ
        tmp_group_func_data &= ~(0x07 << ((port_num - (port_num_func<<3)) << 2));
        //pullֵǷpullĴ
    }
    if(tmp_group_func_addr)                              //ֻҪ¹ĴַͿԶӲֵ
    {                                                    //ôеֵȫдӲĴ
        *tmp_group_func_addr   = tmp_group_func_data;    //дܼĴ
    }

    //free(p_handler);                                //ͷڴ
	eGon2_free((char *)p_handler);

    return EGON2_OK;
}
/*
**********************************************************************************************************************
*                                               CSP_PIN_Get_All_Gpio_Status
*
* Description:
*				ȡûGPIO״̬
* Arguments  :
*		p_handler	:	handler
*		gpio_status	:	ûݵ
*		gpio_count_max	:	Խ
*       if_get_user_set_flag   :   ȡ־ʾȡû趨ݻʵ
* Returns    :
*
* Notes      :
*
**********************************************************************************************************************
*/
__s32  eGon2_GPIO_Get_All_PIN_Status(__hdle p_handler, user_gpio_set_t *gpio_status, __u32 gpio_count_max, __u32 if_get_from_hardware)
{
    char               *tmp_buf;                                        //תchar
    __u32               group_count_max;                                //GPIO
    system_gpio_set_t  *user_gpio_set, *tmp_sys_gpio_data;
    user_gpio_set_t  *script_gpio;
    __u32               port_num_func, port_num_pull;
    volatile __u32     *tmp_group_func_addr = NULL, *tmp_group_pull_addr;
    volatile __u32     *tmp_group_data_addr, *tmp_group_dlevel_addr;
    __u32               port, port_num;
    __u32               pre_port = 0x7fffffff, pre_port_num_func = 0x7fffffff, pre_port_num_pull = 0x7fffffff;
    __u32               i;

    //鴫ľЧ
    if((!p_handler) || (!gpio_status))
    {
        return EGON2_FAIL;
    }
    if(gpio_count_max <= 0)
    {
        return EGON2_FAIL;
    }
    tmp_buf = (char *)p_handler;
    group_count_max = *(int *)tmp_buf;
    if(group_count_max <= 0)
    {
        return EGON2_FAIL;
    }
    user_gpio_set = (system_gpio_set_t *)(tmp_buf + 16);
    if(group_count_max > gpio_count_max)
    {
        group_count_max = gpio_count_max;
    }
	//ȡû
	//ʾȡû
	if(!if_get_from_hardware)
	{
	    for(i = 0; i < group_count_max; i++)
	    {
    	    tmp_sys_gpio_data = user_gpio_set + i;             //tmp_sys_gpio_dataָGPIOռ
    	    script_gpio       = gpio_status + i;               //script_gpioָûĿռ

    	    script_gpio->port      = tmp_sys_gpio_data->port;                       //port
    	    script_gpio->port_num  = tmp_sys_gpio_data->port_num;                   //port_num
    	    script_gpio->pull      = tmp_sys_gpio_data->user_gpio_status.pull;      //pull
    	    script_gpio->mul_sel   = tmp_sys_gpio_data->user_gpio_status.mul_sel;   //
    	    script_gpio->drv_level = tmp_sys_gpio_data->user_gpio_status.drv_level; //
    	    script_gpio->data      = tmp_sys_gpio_data->user_gpio_status.data;      //data
    	    strcpy(script_gpio->gpio_name, tmp_sys_gpio_data->gpio_name);
	    }
	}
	else
	{
		for(i = 0; i < group_count_max; i++)
    	{
    		tmp_sys_gpio_data = user_gpio_set + i;             //tmp_sys_gpio_dataָGPIOռ
    		script_gpio       = gpio_status + i;               //script_gpioָûĿռ

    	    port     = tmp_sys_gpio_data->port;                //˿ֵ
    	    port_num = tmp_sys_gpio_data->port_num;            //˿еĳһGPIO

            script_gpio->port = port;                          //port
            script_gpio->port_num  = port_num;                 //port_num
            strcpy(script_gpio->gpio_name, tmp_sys_gpio_data->gpio_name);

            port_num_func = (port_num >> 3);
            port_num_pull = (port_num >> 4);

            if(tmp_group_func_addr)                             //ĴǷ񱻸ֵ
            {
                if((port_num_pull != pre_port_num_pull) || (port != pre_port))    //ֵǰŵĶ˿ڲһ£ڵpullĴһ
                {
                    tmp_group_func_addr    = PIO_REG_CFG(port, port_num_func);   //¹ܼĴַ
                    tmp_group_pull_addr    = PIO_REG_PULL(port, port_num_pull);   //pullĴ
                    tmp_group_dlevel_addr  = PIO_REG_DLEVEL(port, port_num_pull); //levelĴ
                    tmp_group_data_addr    = PIO_REG_DATA(port);                  //dataĴ
                }
                else if(pre_port_num_func != port_num_func)                       //ֵǰŵĹܼĴһ
                {
                    tmp_group_func_addr    = PIO_REG_CFG(port, port_num_func);   //¹ܼĴַ
                }
            }
            else
            {
                tmp_group_func_addr    = PIO_REG_CFG(port, port_num_func);   //¹ܼĴַ
                tmp_group_pull_addr    = PIO_REG_PULL(port, port_num_pull);   //pullĴ
                tmp_group_dlevel_addr  = PIO_REG_DLEVEL(port, port_num_pull); //levelĴ
                tmp_group_data_addr    = PIO_REG_DATA(port);                  //dataĴ
            }

            pre_port_num_pull = port_num_pull;
            pre_port_num_func = port_num_func;
            pre_port          = port;
            //ûؼֵ
            script_gpio->pull      = (*tmp_group_pull_addr   >> ((port_num - (port_num_pull<<4))<<1)) & 0x03;    //pull
    	    script_gpio->drv_level = (*tmp_group_dlevel_addr >> ((port_num - (port_num_pull<<4))<<1)) & 0x03;    //
    	    script_gpio->mul_sel   = (*tmp_group_func_addr   >> ((port_num - (port_num_pull<<3))<<2)) & 0x07;    //
    	    if(script_gpio->mul_sel <= 1)
    	    {
    	    	script_gpio->data  = (*tmp_group_data_addr   >>   port_num) & 0x01;                              //data
        	}
        	else
        	{
        		script_gpio->data = -1;
        	}
        }
	}

	return EGON2_OK;
}
/*
**********************************************************************************************************************
*                                               CSP_PIN_Get_All_Gpio_Status
*
* Description:
*				ȡûGPIO״̬
* Arguments  :
*		p_handler	:	handler
*		gpio_status	:	ûݵ
*		gpio_name	:	ҪGPIO
*       if_get_user_set_flag   :   ȡ־ʾȡû趨ݻʵ
* Returns    :
*
* Notes      :
*
**********************************************************************************************************************
*/
__s32  eGon2_GPIO_Get_One_PIN_Status(__hdle p_handler, user_gpio_set_t *gpio_status, const char *gpio_name, __u32 if_get_from_hardware)
{
    char               *tmp_buf;                                        //תchar
    __u32               group_count_max;                                //GPIO
    system_gpio_set_t  *user_gpio_set, *tmp_sys_gpio_data;
    __u32               port_num_func, port_num_pull;
    __u32               port, port_num;
    __u32               i, tmp_val1, tmp_val2;

    //鴫ľЧ
    if((!p_handler) || (!gpio_status) || (!gpio_name))
    {
        return EGON2_FAIL;
    }
    tmp_buf = (char *)p_handler;
    group_count_max = *(int *)tmp_buf;
    if(group_count_max <= 0)
    {
        return EGON2_FAIL;
    }
    user_gpio_set = (system_gpio_set_t *)(tmp_buf + 16);
	//ȡû
	//ʾȡû

    for(i = 0; i < group_count_max; i++)
    {
        tmp_sys_gpio_data = user_gpio_set + i;             //tmp_sys_gpio_dataָGPIOռ
        if(strcmp(gpio_name, tmp_sys_gpio_data->gpio_name))
        {
            continue;
        }
        strcpy(gpio_status->gpio_name, tmp_sys_gpio_data->gpio_name);
        port                   = tmp_sys_gpio_data->port;
        port_num               = tmp_sys_gpio_data->port_num;
        gpio_status->port      = port;                                              //port
	    gpio_status->port_num  = port_num;                                          //port_num

        if(!if_get_from_hardware)                                                    //ǰҪûƵ
        {
        	gpio_status->mul_sel   = tmp_sys_gpio_data->user_gpio_status.mul_sel;   //ûж
            gpio_status->pull      = tmp_sys_gpio_data->user_gpio_status.pull;      //ûжpull
            gpio_status->drv_level = tmp_sys_gpio_data->user_gpio_status.drv_level; //ûж
	        gpio_status->data      = tmp_sys_gpio_data->user_gpio_status.data;      //ûжdata
        }
        else                                                                        //ǰĴʵʵĲ
        {
            port_num_func = (port_num >> 3);
            port_num_pull = (port_num >> 4);

            tmp_val1 = (port_num - (port_num_func<<3)<<2);
            tmp_val2 = (port_num - (port_num_pull<<4)<<1);
            gpio_status->mul_sel   = (PIO_REG_CFG_VALUE(port, port_num_func)>>tmp_val1) & 0x07;       //ӲжܼĴ
            gpio_status->pull      = (PIO_REG_PULL_VALUE(port, port_num_pull)>>tmp_val2) & 0x03;      //ӲжpullĴ
            gpio_status->drv_level = (PIO_REG_DLEVEL_VALUE(port, port_num_pull)>>tmp_val2) & 0x03;    //ӲжlevelĴ
            if(gpio_status->mul_sel <= 1)
            {
                gpio_status->data = (PIO_REG_DATA_VALUE(port) >> port_num) & 0x01;                     //ӲжdataĴ
            }
            else
            {
                gpio_status->data = -1;
            }
        }

        break;
    }

    return EGON2_OK;
}
/*
**********************************************************************************************************************
*                                               CSP_PIN_Set_One_Gpio_Status
*
* Description:
*				ȡûGPIOĳһ״̬
* Arguments  :
*		p_handler	:	handler
*		gpio_status	:	ûݵ
*		gpio_name	:	ҪGPIO
*       if_get_user_set_flag   :   ȡ־ʾȡû趨ݻʵ
* Returns    :
*
* Notes      :
*
**********************************************************************************************************************
*/
__s32  eGon2_GPIO_Set_One_PIN_Status(__hdle p_handler, user_gpio_set_t *gpio_status, const char *gpio_name, __u32 if_set_to_current_input_status)
{
    char               *tmp_buf;                                        //תchar
    __u32               group_count_max;                                //GPIO
    system_gpio_set_t  *user_gpio_set, *tmp_sys_gpio_data;
    user_gpio_set_t     script_gpio;
    volatile __u32     *tmp_addr;
    __u32               port_num_func, port_num_pull;
    __u32               port, port_num;
    __u32               i, reg_val, tmp_val;

    //鴫ľЧ
    if((!p_handler) || (!gpio_name))
    {
        return EGON2_FAIL;
    }
    if((if_set_to_current_input_status) && (!gpio_status))
    {
        return EGON2_FAIL;
    }
    tmp_buf = (char *)p_handler;
    group_count_max = *(int *)tmp_buf;
    if(group_count_max <= 0)
    {
        return EGON2_FAIL;
    }
    user_gpio_set = (system_gpio_set_t *)(tmp_buf + 16);
	//ȡû
	//ʾȡû
    for(i = 0; i < group_count_max; i++)
    {
        tmp_sys_gpio_data = user_gpio_set + i;             //tmp_sys_gpio_dataָGPIOռ
        if(strcmp(gpio_name, tmp_sys_gpio_data->gpio_name))
        {
            continue;
        }

        port          = tmp_sys_gpio_data->port;                           //port
        port_num      = tmp_sys_gpio_data->port_num;                       //port_num
        port_num_func = (port_num >> 3);
        port_num_pull = (port_num >> 4);

        if(if_set_to_current_input_status)                                 //ݵǰû趨
        {
            //޸FUCNĴ
            script_gpio.mul_sel   = gpio_status->mul_sel;
            script_gpio.pull      = gpio_status->pull;
            script_gpio.drv_level = gpio_status->drv_level;
            script_gpio.data      = gpio_status->data;
        }
        else
        {
            script_gpio.mul_sel   = tmp_sys_gpio_data->user_gpio_status.mul_sel;
            script_gpio.pull      = tmp_sys_gpio_data->user_gpio_status.pull;
            script_gpio.drv_level = tmp_sys_gpio_data->user_gpio_status.drv_level;
            script_gpio.data      = tmp_sys_gpio_data->user_gpio_status.data;
        }

        if(script_gpio.mul_sel >= 0)
        {
        	tmp_addr = PIO_REG_CFG(port, port_num_func);
            reg_val = *tmp_addr;                      								 //޸FUNCĴ
            tmp_val = (port_num - (port_num_func<<3))<<2;
            reg_val &= ~(0x07 << tmp_val);
            reg_val |=  (script_gpio.mul_sel) << tmp_val;
            *tmp_addr = reg_val;
        }
        //޸PULLĴ
        if(script_gpio.pull >= 0)
        {
        	tmp_addr = PIO_REG_PULL(port, port_num_pull);
            reg_val = *tmp_addr;								                     //޸FUNCĴ
            tmp_val = (port_num - (port_num_pull<<4))<<1;
            reg_val &= ~(0x07 << tmp_val);
            reg_val |=  (script_gpio.pull) << tmp_val;
            *tmp_addr = reg_val;
        }
        //޸DLEVELĴ
        if(script_gpio.drv_level >= 0)
        {
        	tmp_addr = PIO_REG_DLEVEL(port, port_num_pull);
            reg_val = *tmp_addr;                       								  //޸FUNCĴ
            tmp_val = (port_num - (port_num_pull<<4))<<1;
            reg_val &= ~(0x07 << tmp_val);
            reg_val |=  (script_gpio.drv_level) << tmp_val;
            *tmp_addr = reg_val;
        }
        //޸dataĴ
        if(script_gpio.mul_sel == 1)
        {
            if(script_gpio.data >= 0)
            {
            	tmp_addr = PIO_REG_DATA(port);
                reg_val = *tmp_addr;                                   				   //޸DATAĴ
                reg_val &= ~(0x01 << port_num);
                reg_val |=  (script_gpio.data & 0x01) << port_num;
                *tmp_addr = reg_val;
            }
        }

        break;
    }

    return EGON2_OK;
}

__s32  eGon2_GPIO_Set_One_PIN_IO_Status(__hdle p_handler, __u32 if_set_to_output_status, const char *gpio_name)
{
    char               *tmp_buf;                                        //תchar
    __u32               group_count_max;                                //GPIO
    system_gpio_set_t  *user_gpio_set = NULL, *tmp_sys_gpio_data;
    volatile __u32      *tmp_group_func_addr = NULL;
    __u32               port, port_num, port_num_func;
    __u32				i, reg_val;

    //鴫ľЧ
    if(!p_handler)
    {
        return EGON2_FAIL;
    }
    if(if_set_to_output_status > 1)
    {
        return EGON2_FAIL;
    }
    tmp_buf = (char *)p_handler;
    group_count_max = *(int *)tmp_buf;
    tmp_sys_gpio_data = (system_gpio_set_t *)(tmp_buf + 16);
    if(group_count_max == 0)
    {
        return EGON2_FAIL;
    }
    else if(group_count_max == 1)
	{
		user_gpio_set = tmp_sys_gpio_data;
	}
	else if(gpio_name)
	{
		for(i=0; i<group_count_max; i++)
		{
			if(strcmp(gpio_name, tmp_sys_gpio_data->gpio_name))
			{
			    tmp_sys_gpio_data ++;
				continue;
			}
			user_gpio_set = tmp_sys_gpio_data;
			break;
		}
	}
	if(!user_gpio_set)
	{
		return EGON2_FAIL;
	}

    port     = user_gpio_set->port;
    port_num = user_gpio_set->port_num;
    port_num_func = port_num >> 3;

    tmp_group_func_addr = PIO_REG_CFG(port, port_num_func);
    reg_val = *tmp_group_func_addr;
    reg_val &= ~(0x07 << ((port_num - (port_num_func<<3)<<2)));
    reg_val |=  (if_set_to_output_status << ((port_num - (port_num_func<<3)<<2)));
    *tmp_group_func_addr = reg_val;

    return EGON2_OK;
}
__s32  eGon2_GPIO_Set_One_PIN_Pull(__hdle p_handler, __u32 set_pull_status, const char *gpio_name)
{
    char               *tmp_buf;                                        //תchar
    __u32               group_count_max;                                //GPIO
    system_gpio_set_t  *user_gpio_set, *tmp_sys_gpio_data;
    volatile __u32      *tmp_group_func_addr = NULL;
    __u32               port, port_num, port_num_pull;
	__u32				i, reg_val;
    //鴫ľЧ
    if(!p_handler)
    {
        return EGON2_FAIL;
    }
    if(set_pull_status >= 4)
    {
        return EGON2_FAIL;
    }
    tmp_buf = (char *)p_handler;
    group_count_max = *(int *)tmp_buf;
    tmp_sys_gpio_data = (system_gpio_set_t *)(tmp_buf + 16);
    if(group_count_max == 0)
    {
        return EGON2_FAIL;
    }
    else if(group_count_max == 1)
	{
		user_gpio_set = tmp_sys_gpio_data;
	}
	else if(gpio_name)
	{
		for(i=0; i<group_count_max; i++)
		{
			if(strcmp(gpio_name, tmp_sys_gpio_data->gpio_name))
			{
			    tmp_sys_gpio_data ++;
				continue;
			}
			user_gpio_set = tmp_sys_gpio_data;
			break;
		}
	}
	if(!user_gpio_set)
	{
		return EGON2_FAIL;
	}

    port     = user_gpio_set->port;
    port_num = user_gpio_set->port_num;
    port_num_pull = port_num >> 4;

    tmp_group_func_addr = PIO_REG_PULL(port, port_num_pull);
    reg_val = *tmp_group_func_addr;
    reg_val &= ~(0x03 << ((port_num - (port_num_pull<<4)<<1)));
    reg_val |=  (set_pull_status << ((port_num - (port_num_pull<<4)<<1)));
    *tmp_group_func_addr = reg_val;

    return EGON2_OK;
}
__s32  eGon2_GPIO_Set_One_PIN_driver_level(__hdle p_handler, __u32 set_driver_level, const char *gpio_name)
{
    char               *tmp_buf;                                        //תchar
    __u32               group_count_max;                                //GPIO
    system_gpio_set_t  *user_gpio_set, *tmp_sys_gpio_data;
    volatile __u32      *tmp_group_func_addr = NULL;
    __u32               port, port_num, port_num_dlevel;
	__u32				i, reg_val;
    //鴫ľЧ
    if(!p_handler)
    {
        return EGON2_FAIL;
    }
    if(set_driver_level >= 4)
    {
        return EGON2_FAIL;
    }
    tmp_buf = (char *)p_handler;
    group_count_max = *(int *)tmp_buf;
    tmp_sys_gpio_data = (system_gpio_set_t *)(tmp_buf + 16);

    if(group_count_max == 0)
    {
        return EGON2_FAIL;
    }
    else if(group_count_max == 1)
	{
		user_gpio_set = tmp_sys_gpio_data;
	}
	else if(gpio_name)
	{
		for(i=0; i<group_count_max; i++)
		{
			if(strcmp(gpio_name, tmp_sys_gpio_data->gpio_name))
			{
			    tmp_sys_gpio_data ++;
				continue;
			}
			user_gpio_set = tmp_sys_gpio_data;
			break;
		}
	}
	if(!user_gpio_set)
	{
		return EGON2_FAIL;
	}

    port     = user_gpio_set->port;
    port_num = user_gpio_set->port_num;
    port_num_dlevel = port_num >> 4;

    tmp_group_func_addr = PIO_REG_DLEVEL(port, port_num_dlevel);
    reg_val = *tmp_group_func_addr;
    reg_val &= ~(0x03 << ((port_num - (port_num_dlevel<<4)<<1)));
    reg_val |=  (set_driver_level << ((port_num - (port_num_dlevel<<4)<<1)));
    *tmp_group_func_addr = reg_val;

    return EGON2_OK;
}
__s32  eGon2_GPIO_Read_One_PIN_Value(__hdle p_handler, const char *gpio_name)
{
    char               *tmp_buf;                                        //תchar
    __u32               group_count_max;                                //GPIO
    system_gpio_set_t  *user_gpio_set = NULL, *tmp_sys_gpio_data;
    __u32               port, port_num, port_num_func, func_val;
	__u32				i, reg_val;
    //鴫ľЧ
    if(!p_handler)
    {
        return EGON2_FAIL;
    }
    tmp_buf = (char *)p_handler;
    group_count_max = *(int *)tmp_buf;
    tmp_sys_gpio_data = (system_gpio_set_t *)(tmp_buf + 16);

    if(group_count_max == 0)
    {
        return EGON2_FAIL;
    }
    else if(group_count_max == 1)
	{
		user_gpio_set = tmp_sys_gpio_data;
	}
	else if(gpio_name)
	{
		for(i=0; i<group_count_max; i++)
		{
			if(strcmp(gpio_name, tmp_sys_gpio_data->gpio_name))
			{
			    tmp_sys_gpio_data ++;
				continue;
			}
			user_gpio_set = tmp_sys_gpio_data;
			break;
		}
	}
	if(!user_gpio_set)
	{
		return EGON2_FAIL;
	}

    port     = user_gpio_set->port;
    port_num = user_gpio_set->port_num;
    port_num_func = port_num >> 3;

    reg_val  = PIO_REG_CFG_VALUE(port, port_num_func);
    func_val = (reg_val >> (port_num - (port_num_func<<3)<<2)) & 0x07;
    if(func_val == 0)
    {
        reg_val = (PIO_REG_DATA_VALUE(port) >> port_num) & 0x01;

        return reg_val;
    }

    return EGON2_FAIL;
}
__s32  eGon2_GPIO_Write_One_PIN_Value(__hdle p_handler, __u32 value_to_gpio, const char *gpio_name)
{
    char               *tmp_buf;                                        //תchar
    __u32               group_count_max;                                //GPIO
    system_gpio_set_t  *user_gpio_set = NULL, *tmp_sys_gpio_data;
    volatile __u32     *tmp_group_data_addr = NULL;
    __u32               port, port_num, port_num_func, func_val;
	__u32				i, reg_val;
    //鴫ľЧ
    if(!p_handler)
    {
        return EGON2_FAIL;
    }
    if(value_to_gpio >= 2)
    {
        return EGON2_FAIL;
    }
    tmp_buf = (char *)p_handler;
    group_count_max = *(int *)tmp_buf;
    tmp_sys_gpio_data = (system_gpio_set_t *)(tmp_buf + 16);

    if(group_count_max == 0)
    {
        return EGON2_FAIL;
    }
    else if(group_count_max == 1)
	{
		user_gpio_set = tmp_sys_gpio_data;
	}
	else if(gpio_name)
	{
		for(i=0; i<group_count_max; i++)
		{
			if(strcmp(gpio_name, tmp_sys_gpio_data->gpio_name))
			{
                tmp_sys_gpio_data ++;
				continue;
			}
			user_gpio_set = tmp_sys_gpio_data;
			break;
		}
	}
	if(!user_gpio_set)
	{
		return EGON2_FAIL;
	}

    port     = user_gpio_set->port;
    port_num = user_gpio_set->port_num;
    port_num_func = port_num >> 3;

    reg_val  = PIO_REG_CFG_VALUE(port, port_num_func);
    func_val = (reg_val >> (port_num - (port_num_func<<3)<<2)) & 0x07;
    if(func_val == 1)
    {
        tmp_group_data_addr = PIO_REG_DATA(port);
        reg_val = *tmp_group_data_addr;
        reg_val &= ~(1 << port_num);
        reg_val |=  (value_to_gpio << port_num);
        *tmp_group_data_addr = reg_val;

        return EGON2_OK;
    }

    return EGON2_FAIL;
}


